<script setup>
import { computed, watch } from "vue";
import { useStore } from "vuex";
import FoldOut from "@components/Template/FoldOut.vue";
import SessionLauncher from "@components/Game/SessionLauncher.vue";

const props = defineProps({
  levelId: { type: String, required: true },
  levelName: { type: String, required: false, default: "" },
});
const store = useStore();

const sessions = computed(() => store.getters["live/sessionsOfLevel"](props.levelId));
const selected = computed(() => store.state.live.session);
const selectedObject = computed(() => {
  return sessions.value.find((s) => s._id === selected.value);
});

function openTab(e, tabName) {
  // hide everything
  const links = document.getElementsByClassName("tab-link");
  const tabs = document.getElementsByClassName("tab-content");
  Array.from(links).forEach((node) => node.classList.remove("is-active"));
  Array.from(tabs).forEach((node) => (node.style.display = "none"));
  // show selection
  document.getElementById(tabName).style.display = "block";
  e.currentTarget.classList.add("is-active");
}

function sessionSelect(session) {
  store.dispatch("live/selectSession", session);
}

function sessionDelete(session) {
  store.dispatch("live/cancelSession", { session });
}

watch(
  sessions,
  (newList) => {
    if (newList?.length == 0) return;
    if (newList?.length == 1) sessionSelect(newList[0]._id);
    if (newList.some((s) => s._id == store.state.live.session)) return; // Note: if a session based on this level is already selected (e.g. from GameOverview) don't select anything else
    if (newList?.length > 1) sessionSelect(newList[newList.length - 1]._id);
  },
  { immediate: true },
);
</script>

<template>
  <div class="is-clipped-container is-flex is-flex-direction-column is-unselectable width-content">
    <div class="tabs is-boxed has-text-weight-semibold">
      <ul>
        <li class="tab-link is-active" @click="openTab($event, 'tab_session')">
          <a>SESSIONS</a>
        </li>
        <li class="tab-link" @click="openTab($event, 'tab_things')">
          <a>SESSION DETAILS</a>
        </li>
      </ul>
    </div>
    <div class="tab-container is-scroll-container px-2 has-text-black">
      <!-- TAB CONTENT SESSIONS -->
      <div id="tab_session" class="tab-content">
        <!-- LIST OF SESSIONS -->
        <div
          v-for="session in sessions"
          :key="session._id"
          class="box p-2 field is-grouped"
          :class="[selected == session._id ? 'has-background-is-live' : 'has-background-light']"
        >
          <div class="control is-expanded is-clipped has-overflow-ellipsis" @click="sessionSelect(session._id)">
            <span class="has-text-weight-semibold">{{ session.name }}</span>
            <div v-for="(value, key, i) in session.references" :key="session._id + key + i" class="is-size-7">
              {{ key }}:
              <i class="is-italic">{{ value[0]?.name || value[0]?.id }}</i>
            </div>
          </div>
          <div @click="sessionDelete(session)">
            <Icon :icon="'trash-2'" />
          </div>
        </div>
        <hr />
        <!-- ADD NEW SESSION -->
        <FoldOut>
          <template #header>
            <button class="mt-4 button is-dark is-fullwidth">Create Session</button>
          </template>
          <template #default="{ toggleFold }">
            <SessionLauncher
              :level-id="levelId"
              :level-name="levelName"
              @launched="sessionSelect"
              @close="toggleFold"
            />
          </template>
        </FoldOut>
      </div>
      <!-- END OF TAB CONTENT SESSIONS -->

      <!-- TAB CONTENT DETAILS -->
      <div id="tab_things" class="tab-content" style="display: none">
        <h2 v-if="selectedObject" class="is-size-5 mb-1">
          {{ selectedObject?.name }}
        </h2>
        <div v-if="selectedObject" :style="{ 'max-width': '250px' }">
          <div class="is-size-7">
            <details v-for="(value, key, i) in selectedObject" :key="selectedObject._id + key + i">
              <summary>{{ key }}</summary>
              {{ value }}
            </details>
          </div>
        </div>
      </div>
      <!-- END OF TAB CONTENT DETAILS -->
    </div>
  </div>
</template>
